



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>二十二、Java基础--------GUI入门</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">二十二、Java基础--------GUI入门</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 22:10:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在java学习过程中GUI是一个比较特殊的知识体系（笔者对安卓不是很了解），似乎在为安卓的学习做着准备，本文将将展示一个综合案例。</p>
<p><strong>创建一个类似于记事本的程序，包含打开与保存功能。</strong></p>
<div>
<pre class="prettyprint linenums">package GUI;

import java.awt.FileDialog;<br />
import java.awt.Frame;<br />
import java.awt.Menu;<br />
import java.awt.MenuBar;<br />
import java.awt.MenuItem;<br />
import java.awt.TextArea;<br />
import java.awt.event.ActionEvent;<br />
import java.awt.event.ActionListener;<br />
import java.awt.event.WindowAdapter;<br />
import java.awt.event.WindowEvent;<br />
import java.io.BufferedReader;<br />
import java.io.BufferedWriter;<br />
import java.io.File;<br />
import java.io.FileReader;<br />
import java.io.FileWriter;

public class MyMenu2 {<br />
    private Frame f;//声明窗体<br />
    private MenuBar bar;//声明一个bar,表示工具条，比如：文件、Edit、Source等等<br />
    private TextArea ta;//文本区域，用于显示打开文件的内容<br />
    private Menu filebMenu;//我的理解是为上面的bar命名，当然还包含一个添加选项的功能。。。。。。不是很清楚<br />
    private FileDialog openDia,SaveDia;//打开新的对话框、与保存时出现的对话框<br />
    private MenuItem closeItem,saveItem,openItem;//三个选项，用以触发关闭，保存，打开事件<br />
    private File file;<br />
    MyMenu2()<br />
    {<br />
        init();<br />
    }<br />
    void init(){<br />
        f=new Frame("my farme");//窗体的名称<br />
        f.setBounds(300,100,650,600);//setBounds(int x, int y, int width, int height)<br />
//        f.setLayout(new FlowLayout());<br />
        bar=new MenuBar();<br />
        filebMenu=new Menu("文件");

        openItem=new MenuItem("打开");<br />
        saveItem=new MenuItem("保存");<br />
        closeItem=new MenuItem("退出");<br />
        ta=new TextArea();

        filebMenu.add(openItem);//将打开、保存、关闭对话框附加到工具条上<br />
        filebMenu.add(saveItem);<br />
        filebMenu.add(closeItem);<br />
        bar.add(filebMenu);//将工具条附加到bar上。<br />
        f.setMenuBar(bar);//将bar添加到窗体上<br />
        f.setVisible(true);//设置窗体可见<br />
        openDia=new FileDialog(f,"我要打开",FileDialog.LOAD);//定义一个打开的窗体对象<br />
        SaveDia=new FileDialog(f,"我要保存",FileDialog.SAVE);//定义一个打开保存文件的对象<br />
        f.add(ta);//将文本附加到窗体<br />
        myEvent();<br />
    }<br />
    //定义一些列事件，用于处理不同的请求<br />
    public void myEvent(){<br />
        /*<br />
         * 处理打开触发器<br />
         *         1、打开窗体可见<br />
         *         2、获取文件的路径以及文件名<br />
         *         3、读取文件<br />
         *         4、将文件内容显示到文本区域<br />
         * */<br />
        openItem.addActionListener(new ActionListener() {

            @Override<br />
            public void actionPerformed(ActionEvent e) {<br />
                //使打开对话框可见<br />
                openDia.setVisible(true);<br />
                String dirPath=openDia.getDirectory();<br />
                String fileName=openDia.getFile();<br />
                System.out.println(dirPath+":"+fileName);<br />
                if(dirPath==null||fileName==null)<br />
                    return;<br />
                File file=new File(dirPath,fileName);<br />
                try{<br />
                    ta.setText("");<br />
                    BufferedReader br=new BufferedReader(new FileReader(file));<br />
                    String temp="";<br />
                    while((temp=br.readLine())!=null){<br />
                        ta.append(temp+"\r\n");<br />
                    }<br />
                    br.close();

                }catch (Exception ex) {<br />
                    ex.printStackTrace();<br />
                }

            }<br />
        });<br />
        /*<br />
         * 处理保存触发器的内容<br />
         * */<br />
        saveItem.addActionListener(new ActionListener() {<br />
            public void actionPerformed(ActionEvent e) {<br />
                if(file==null)<br />
                {<br />
                    SaveDia.setVisible(true);<br />
                    String dirPath=SaveDia.getDirectory();<br />
                    String fileName=SaveDia.getFile();<br />
                    if(dirPath==null||fileName==null)<br />
                        return;<br />
                    file=new File(dirPath,fileName);

                }<br />
                try{<br />
                    BufferedWriter bw=new BufferedWriter(new FileWriter(file));<br />
                    String text=ta.getText();<br />
                    bw.write(text);<br />
                    bw.close();<br />
                }<br />
                catch (Exception ex) {<br />
                    throw new RuntimeException();<br />
                }

            }<br />
        });<br />
        /*<br />
         * 处理关闭触发器<br />
         * */<br />
        closeItem.addActionListener(new ActionListener() {

            @Override<br />
            public void actionPerformed(ActionEvent e) {<br />
                System.exit(0);

            }<br />
        });

        /*<br />
         * 处理点击窗体上的 &lsquo;X' 时的事件<br />
         * */<br />
        f.addWindowListener(new WindowAdapter() {<br />
            @Override<br />
            public void windowClosing(WindowEvent e) {<br />
                System.exit(0);<br />
            }

        });<br />
    }<br />
    public static void main(String[] args) {<br />
        MyMenu2 menu=new MyMenu2();<br />
    }<br />
}</pre>
</div>
<p>运行效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/523469/201410/281446139093136.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/523469/201410/281448201446371.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r52orq.html">SignalR的Javascript客户端API使用方式整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwyjl38.html">mysql 的2个关于事务和安全性的参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zn6kn8.html">C&plus;&plus;不用任何算术运算符实现整数加法</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elnpmq.html">python学习-day14：集合，函数，格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96r22y9.html">php 继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1em5x9.html">php 迭代器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmo6p09.html">微信朋友圈如何同时分享&lpar;图片&plus;文字&rpar; Android版</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmozj19.html">UIView的user Interaction Enabled属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ykegnq.html">sql2005数据库转换成sql2000</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdw7ye8.html">js如何实现一定时间后去执行一个函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w104wq.html">细谈Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydk6yxq.html">uva  11825  Hackers&amp;amp&semi;&num;39&semi; Crackdown   （状压dp，子集枚举）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x2xwv8.html">poj 2785 4 Values whose Sum is 0（折半枚举（双向搜索））</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj1j4lq.html">&lbrack;MySQL&rsqb;--&amp;amp&semi;gt&semi;查询5天之内过生日的同事中的闰年2月29日问题的解决过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8merjj2q.html">&lbrack;机房练习赛7&period;26&rsqb; YYR字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1e17q.html">&lbrack;Luogu 1122&rsqb; 最大子树和</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllk5e6q.html">python系统编程（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1v7jl9.html">Entity Framework教程翻译 ----  系列教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1o5w1q.html">c&num;通用配置文件读写类与格式转换（xml&comma;ini&comma;json）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw756j9.html">Ubuntu 14&period;10 下Spark on yarn安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq15e559.html">ListView使用item显示不同布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq44xoeq.html">Android Studio插件美化Android Studio&comma;文艺清新范</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96m6pj8.html">JavaScript、tabel切换完整版&mdash;自动切换&mdash;鼠标移入停止-移开运行</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxl0edq.html">Java 中多条件排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw5kdrq.html">JAVA实现复制文件夹</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn2jekq.html">关于sort排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxo2o0q.html">centos 查看版本（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e5mre8.html">input range样式更改&comma;模拟滑块</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7le1x8.html">上传图片插件鼠标手cursor&colon;pointer&semi;不生效</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ov475q.html">spring&lowbar;异常提示1</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
